// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new operations API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for operations API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	PostScanScanUUIDCisDockerBenchmarkResults(params *PostScanScanUUIDCisDockerBenchmarkResultsParams, opts ...ClientOption) (*PostScanScanUUIDCisDockerBenchmarkResultsCreated, error)

	PostScanScanUUIDContentAnalysis(params *PostScanScanUUIDContentAnalysisParams, opts ...ClientOption) (*PostScanScanUUIDContentAnalysisCreated, error)

	PostScanScanUUIDResults(params *PostScanScanUUIDResultsParams, opts ...ClientOption) (*PostScanScanUUIDResultsCreated, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  PostScanScanUUIDCisDockerBenchmarkResults reports an image c i s docker benchmark scan for a specific scan UUID
*/
func (a *Client) PostScanScanUUIDCisDockerBenchmarkResults(params *PostScanScanUUIDCisDockerBenchmarkResultsParams, opts ...ClientOption) (*PostScanScanUUIDCisDockerBenchmarkResultsCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostScanScanUUIDCisDockerBenchmarkResultsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "PostScanScanUUIDCisDockerBenchmarkResults",
		Method:             "POST",
		PathPattern:        "/scan/{scan-uuid}/cisDockerBenchmark/results",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostScanScanUUIDCisDockerBenchmarkResultsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostScanScanUUIDCisDockerBenchmarkResultsCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PostScanScanUUIDCisDockerBenchmarkResultsDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  PostScanScanUUIDContentAnalysis reports a content analysis for a specific resource
*/
func (a *Client) PostScanScanUUIDContentAnalysis(params *PostScanScanUUIDContentAnalysisParams, opts ...ClientOption) (*PostScanScanUUIDContentAnalysisCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostScanScanUUIDContentAnalysisParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "PostScanScanUUIDContentAnalysis",
		Method:             "POST",
		PathPattern:        "/scan/{scan-uuid}/contentAnalysis",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostScanScanUUIDContentAnalysisReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostScanScanUUIDContentAnalysisCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PostScanScanUUIDContentAnalysisDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
  PostScanScanUUIDResults reports an image vulnerability scan for a specific scan UUID
*/
func (a *Client) PostScanScanUUIDResults(params *PostScanScanUUIDResultsParams, opts ...ClientOption) (*PostScanScanUUIDResultsCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostScanScanUUIDResultsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "PostScanScanUUIDResults",
		Method:             "POST",
		PathPattern:        "/scan/{scan-uuid}/results",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostScanScanUUIDResultsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostScanScanUUIDResultsCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PostScanScanUUIDResultsDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
